// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_alphabarrier.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of barrier as a service
// $Id: ics_alphabarrier.h,v 1.2 2003/06/24 19:21:20 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_ALPHABARRIER_H_
#define _INUK_ALPHABARRIER_H_
#include <acom>
#include <ics_barrier.h>

namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class AlphaBarrier: virtual public BarrierService {

public:
  /** */
  AlphaBarrier();

  /** */
  void barrier( int key );

  /** */
  virtual void barrier( int key, double alpha );

  /** Set parameter */
  void set_alpha( double alpha )
  { _alpha = alpha; }

protected:
  double _alpha;
};

}

#endif
