// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_bcast_network.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier, L. Pigeon
// Implementation of virtual base class for all bcast algorithms
// Please read node in .cpp file.
// $Id: ics_bcast_network.cpp,v 1.5 2003/07/28 08:05:41 thierry Exp $
//
// ==========================================================================
#include <ics_bcast_network.h>

namespace ICS {

// --------------------------------------------------------------------------
BcastNetwork::BcastNetwork()
  : Network()
{
  set_property("primary",  "false");
  set_property("secondary","true");
  set_name("");
}



// --------------------------------------------------------------------------
BcastNetwork::~BcastNetwork()
{
}



// ---------------------------------------------------------------------------
BcastNetwork::OutChannel::OutChannel( )
 : Network::OutChannel(), _count_peers(0), _peers(0), _index_self(0)
{
}



// ---------------------------------------------------------------------------
BcastNetwork::OutChannel::~OutChannel()
{
}



// ---------------------------------------------------------------------------
void BcastNetwork::OutChannel::init
  ( BcastNetwork* net, int tag, int count_peers, LocalNodeNo* peers, int index_self )
{
  _count_peers = count_peers;
  _peers       = peers;
  _index_self  = index_self;
  
  Network::OutChannel::init(net, tag);
}


 
} // namespace
