//
// $Id: testmap.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// Bcast algorithm
//
#include <iostream>
#include <lighthashmap.h>


int main (int argc, char* argv[])
{
  LHashMap<long,double> map(4);
  LHashMap<long,double>::iterator item;

  map.insert(5,3.1415);
  map.insert(1,6.1415);
  item = map.find(5);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;

  item = map.find(1);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;

  item = map.find(5);
  map.erase(item);
  item = map.find(1);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;

  map.erase(item);
  item = map.find(123);
  if (item ==0) std::cout << "ok" << std::endl;
  else { std::cout << "erreur" << std::endl; return 1; }

  map.insert(5,3.1415);
  map.insert(1,6.1415);
  map.insert(5,4.1415);
  map.insert(1,7.1415);

std::cout << "Multiple entry" << std::endl;
  item = map.find(5);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;
  map.erase(item);

  item = map.find(5);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;
  map.erase(item);
  
  item = map.find(1);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;
  map.erase(item);
  
  item = map.find(1);
  if (item ==0) { std::cout << "erreur" << std::endl; return 1; }
  else std::cout << item->first << " -> " << item->second << std::endl;
  map.erase(item);
  
  return 0;
}
