// =========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/NetworkCore/src/acom_fmtstream.cpp,v $
// (c) INRIA, projet APACHE, 2001
// Author: T. Gautier
//
//
// =========================================================================
#include <acom_fmtstream.h>

namespace ACOM_NET_NAMESPACE { 

// --------------------------------------------------------------------
#define TO_OFFSET(base,data) ((long)data-(long)base)


// --------------------------------------------------------------------
void StreamFormat::write( const Format* fmt, const void* data, size_t count )
{
  write( fmt, OStream::IA, data, count);
}


// --------------------------------------------------------------------
void StreamFormat::write( const Format* fmt, Mode m, const void* data, size_t count )
{
// USed  size_t len = count * fmt->get_size();
  if (m == OStream::IA )
  {
    _ia->push_back( Format::OffSetDataOut( fmt, TO_OFFSET(_base,data), count ));
  }
  else if (m == OStream::DA) 
  {
    _da->push_back( Format::OffSetDataOut( fmt, TO_OFFSET(_base,data), count ));
  }
}


} // namespace 
