// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/NetworkCore/src/acom_router.cpp,v $
// Copyright(c)'2001 by Apache Team
// Authors: Jacques Briat, Thierry Gautier, Cyrille Martin
// ==========================================================================
#include "acom_router.h"

// A0 namespace
namespace ACOM_NET_NAMESPACE {

// ---------------------------------------------------------------------------
// Router class
// ---------------------------------------------------------------------------
Router::Router()
{
}
  
Router::~Router()
{
}
  
  /** Initialisation of the router from ...
  */
void Router::init ( int* argc, char** argv[] )
{
  _routes.clear();
  _nets.clear();
}

  /** Second stage of the initialisation process.
    This function is called after all network has been registered.
  */
void Router::initcommit ()
{
}

  /** Terminate the net...
  */
void Router::terminate ()
{
  _routes.clear();
  _nets.clear();
}

  /** Register a new network to the router.
    This function is an example how to build route, using information on
    a network. It is based on the assumption that all registered network
    permits to reach any node. The route to a node 'N' is the route using
    the first registered network within node 'N' is connected to.
  */
void Router::register_network( Network* net ) throw ()
{
/*
  std::vector<NodeNo> nodes;
  net->get_allnodes(nodes);
  size_t sz = nodes.size();
  _nets.push_back( net );
  for (int i=0; i<sz; ++i) 
  {
    // - look for local route to nodes[i] ???
    if (_routes.size() < nodes[i]) {
      _routes.resize(nodes[i]);
      _routes[nodes[i]] = direction(net, nodes[i]);
    }
    else {
      direction& dir = _routes[nodes[i]];
      if (dir.first ==0) {
        dir.first  = net;
        dir.second = nodes[i];
      }
      else { 
        // a route already exists... 
      }
    }
  }
*/
}

}  // end namespace ATH...
