//
// $Id: pingpong.cpp,v 1.2 2003/07/15 17:32:22 thierry Exp $
//
// test pingpong
//
#include "acom"
#include <cstring>
#include <cstdio>
#include <unistd.h>
#include <sys/time.h>


#define SIZE_MAX  16


namespace AC = acom;

static int rank = 0;
static char* MSG = new char[SIZE_MAX];
static volatile bool isterm = false;
static AC::Network* net = 0;
/*
class PongService: public AC::Service {
public:
	struct Header {
		long id;
	};
	
	PongService()
   : _myiovect(MSG, SIZE_MAX)
  {
  }

  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
		
		Header* h_serv = (Header*) h->get_service_header();
		std::cout << "::Pong: id =" << h_serv->id << ",";
		
		if (e == AC::ComFailure::OK) 
    	std::cout <<"Msg=" <<(char*) iov[0].data << " et Rank=" << rank << std::endl;  
    else
			std::cout << "Error" << std::endl;
		
		isterm =true;
  }
	
	void get_iovect(
    AC::Network::Header* header, AC::IOVectEntry* vector, AC::IOVectSize count  )
  {
    count =1;
    vector = &_myiovect;
  }

protected:
  AC::IOVectEntry _myiovect;
};
static PongService pong;


class PingService: public AC::Service {
public:
	struct Header {
		long id;
	};
	
  PingService()
   : _myiovect(MSG, SIZE_MAX)
  {
  }
  void call ( 
       AC::ComFailure::Code e,      // if any 
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
    
			

    if (e != AC::ComFailure::OK) {
      std::cerr << "Error in msg='" << AC::ComFailure::what(e) 
                << "', #iov" << iov_sz  << ", len[0]" << iov[0].len
                << std::endl;
    }
		

		
			Header* h_serv = (Header*) h->get_service_header();
			std::cout << "::Ping: id =" << h_serv->id << ",";
			std::cout << "Msg=" <<(char*) iov[0].data << " et ";  
      std::cout << "Rank=" << rank << std::endl;
      while(!net);
			
			AC::OutChannel* channel = net->get_local_route(0);
			
			strcpy(MSG,"C'est un pong");
      AC::WriteAndSignal<PongService> ws (channel, &pong, 0, 1);
			ws->h_serv->id = h_serv->id;
			ws->io_v[0] = AC::IOVectEntry(MSG,strlen(MSG)+1);
      ws->post();
			isterm = true;
    

  }
	
  void get_iovect(
    AC::Network::Header* header, AC::IOVectEntry* vector, AC::IOVectSize count  )
  {
    count =1;
    vector = &_myiovect;
  }

protected:
  AC::IOVectEntry _myiovect;
};

static PingService ping;


int doit (int argc, char* argv[])
{
  AC::System::initialize( &argc, &argv );
  AC::Service::Manager.bind (2, &ping);
  AC::Service::Manager.bind (3, &pong);
  AC::System::initcommit( );
	//ath::attach.debugger();

  // Get the network:
 
  AC::System::const_iterator icurr = AC::System::begin_network();
  AC::System::const_iterator iend  = AC::System::end_network();
  if (icurr == iend) {
     std::cout << "No network attached to the process, exit" << std::endl;
     return 0;
  }
  else 
    std::cout << "Using network: " << (*icurr)->get_name() << std::endl;
  net = *icurr;
  rank = net->rank();
  int netcount = net->node_count();

  std::cout << rank << " :: My_rank is=" << rank 
            << " over #nodes=" << netcount << std::endl;

  if (rank ==0) 
  {
    
    //Get a channel:
   
    AC::OutChannel* channel = net->get_local_route(1);

    

      AC::WriteAndSignal<PingService> ws (channel, &ping, 0, 1);
			ws->h_serv->id = 1;
			strcpy(MSG,"C'est un ping");
      ws->io_v[0] = AC::IOVectEntry(MSG, SIZE_MAX);
      ws->post();

    while (!isterm)	usleep( 100);
  }
  else {
		while (!isterm)
    {
      usleep( 100);
    }
  }

  std::cout << rank << " :: Ready to Terminate" << std::endl;
  AC::System::terminate( );
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::Exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
    AC::System::terminate( );
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
    AC::System::terminate( );
  }
}
*/
int doit (int argc, char* argv[]){





}
int main (int argc, char* argv[])
{ 
  try {
   doit(argc,argv);
 
  } catch (std::exception& ex) {
    std::cerr << "Catch exception: " << ex.what() << std::endl;
  }
  catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }

}
