//
// $Id: testbadnet.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test invalid resolv of a network
//
#include <acom>
#include <cstring>
#include <cstdio>
#include <unistd.h>

namespace AC = acom;

int doit (int argc, char* argv[]) throw()
{
  AC::Acom::initialize( &argc, &argv );
  AC::Acom::commit( );

  /* Get the BADNET network:
  */
  try {
    AC::Network* bad_net = AC::Acom::resolv_network("BADNET");
    int my_netrank = bad_net->rank();
  } catch (AC::InvalidArgument& ex) {
    std::cout << "Catch InvalidArgument exception: " << ex.what() << std::endl;
    throw ex;
  }

  AC::Acom::terminate( ); 
}

int main (int argc, char* argv[])
{
  try {
    return doit(argc, argv);
  } catch (AC::InvalidArgument& ex) {
    std::cerr << "Catch InvalidArgument exception: " << ex.what() << std::endl;
  } catch (...) {
    std::cerr << "Unknown exception" << std::endl;
  }
}
