// teste sock pair
#include <unistd.h> //pour le read
#include <stdio.h>
#include <netdb.h>
#include <string.h>
#include <iostream>
#include <stdlib.h>  //pour le atoi
#include "sock.h"
#include "pth.h"

int PORT = 5000;

int doit(int num_port, char* remote_host)
{

   SocketClient s_one;
   s_one.print(std::cout);
   SocketClient s_two;
   s_two.print(std::cout);

   SocketClient s2_one;
   s2_one.print(std::cout);
   SocketClient s2_two;
   s2_two.print(std::cout);


   int pair = sock_pair(&s_one, &s_two);
   int pair2 = sock_pair(&s2_one, &s2_two);

   printf("sock pair =  %d\n",pair);
   printf("sock pair 2=  %d\n",pair2);

   s_one.print(std::cout);
   s_two.print(std::cout);
   s2_one.print(std::cout);
   s2_two.print(std::cout);

   //creation d'ensembles fdset
   FDSet fd_set_null;
   FDSet fd_set2_null;

   fd_set_null.zero();   /* ?? */
   FDSet readset;
   readset.zero();
   readset.set(&s_one);
   readset.set(&s2_one);

   char * msg;
   msg = "coucou";
   printf("sock one va envoyer un message\n");
   int w =s_two.write(msg,strlen(msg));
   std::cout<<"sock one a envoy "<<msg<<" de taille "<<w<<std::endl;


   std::cout<<"avant le select "<<std::endl;
   int sel = select(readset,fd_set2_null,fd_set_null);
   std::cout<<"select = "<<sel<<std::endl;
   std::cout<<"apres le select "<<std::endl;




   char  msg2[6];
   int taille;
   printf("sock two va lire le message !\n");
   if (readset.isready(&s_one) )
   {
        std::cout<<"sock one pret a lire "<<std::endl;

        taille = s_one.read(msg2,6);
        std::cout<<"sock two a lu "<<msg2<<" de taille "<<taille<<std::endl;
   }
   if (readset.isready(&s2_one)  )
   {
        std::cout<<"sock 2 one pret a lire"<<std::endl;

        taille = s2_one.read(msg2,6);
        std::cout<<"sock two a lu "<<msg2<<" de taille "<<taille<<std::endl;
   }


   std::cout<<"avant le print "<<std::endl;
   s_one.print(std::cout);
   s_two.print(std::cout);
   s_one.close();
   s_two.close();
   return pair;
}





int main (int argc, char* argv[])
{
  int father_fd= -1;

   PTH::Pth::initialize(&argc, &argv);
   PTH::Pth::commit();


  if((father_fd=doit(PORT,argv[1]))<0)
    {
      printf("echec de connection\n");
    }
   else
     {
      printf("connection reussie\n");
   //  char* msg;
 //     read(father_fd,&msg,11);
 //     printf("Message recu : %s\n",&msg);
    }
  PTH::Pth::terminate();

  return 0;
}
