// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/Pthread/src/pth_system.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Authors: J. Briat & T. Gautier 
// $Id: pth_system.cpp,v 1.4 2003/06/30 13:36:56 thierry Exp $

// ==========================================================================
// the namespace identifier

#include "pth_ns.h"
#include "pth_pthreadsync.h"
#include "pth_system.h"
#include "pth_log.h"

//#ifdef PTH_USE_TRACER
#include "Pthread_stub_tracer.h"
//#endif

namespace PTH
{
static int count_initialize =0;
void Pth::initialize(int* ac, char*** av ) throw (PosixError)
{ 
std::string TraceFileName;


  ++count_initialize;
  //  std::cout<<count_initialize<<"\nl";
static bool once=true; if (once) once=false; else return;



  try
  {
  } catch(...){
    std::cout << "exception variable" << std::endl << std::flush; 
    return;
  } 
    
  try
  {
    Mutex::init_static();
  } catch(...){
    std::cout << "exception Mutex::init_static" << std::endl << std::flush; 
    return;
  } 
    
    try
  {
    Condition::init_static();
  } catch(...){
    std::cout << "exception Cond::init_static" << std::endl << std::flush; 
    return;

  } 


    
  try
  {
    Thread::init_static();
  } catch(...){
    std::cout << "exception Th::init_static" << std::endl << std::flush; 
    return;

  } 



#ifdef INUK_USE_TRACER 
    //   pid_t getpid(void);
    pid_t CurentPid;
    char* lepid;
    char* lenom;
    
    lepid= (char*) malloc(10);
    CurentPid = getpid();
    sprintf (lepid, "%d", CurentPid);
    TraceFileName += "trace-pth.";
    TraceFileName +=  lepid;
    lenom = (char*) malloc(100);
    lenom = (char*)TraceFileName.c_str();
    std::cout << "init-trace-file:" << lenom << std::endl;

    InukTracer::initialize(lenom);
#else
    InukTracer::initialize( 0);
#endif     
 try
   { static Logger _hidden_logger;_hidden_logger.init();
 		InukLogger=&_hidden_logger;
	//  We must define the file name 
	// we may choose to use it or delay until commit
	// use default in this case...
    InukLogger->bind(0,(&std::clog));
		InukLogger->enable(0);
  } catch(...){
     std::cout << "exception init  InukLogger" << std::endl <<std::flush; 
    return;
  } 

}


void Pth::commit()throw (PosixError)
{
static bool once=true;
if (once) 
  {once=false;}
else 
  {return;}

 InukTracer::commit();
}
 
void Pth::terminate()throw (PosixError)
{
if (--count_initialize > 0) return;
static bool once=true;
if (once) once=false; 
else return;
InukLogger->flush(); 
InukTracer::terminate();

}



} // -namespace
