//
// $Id: EvalOpenChannel.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
//mesure le cot d'une ouverture de channel
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>
#include <iostream>
#include <fstream.h>
#include <sys/time.h>


namespace AC = acom;
//lke noeud 0 communique avec NB_COM  noeuds
static int rank = -1;
static volatile int pingRecu = 0;
AC::Network* net = 0;

std::ofstream fileStream;
//perf time counter
timeval time_init;
timeval time_term;
timeval time_init0;
timeval time_term0;



class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
      	  pingRecu++;
  }
};

static PingService ping;

int initFile (int i)
{
	char file_name[28];
   	strcpy (file_name,"ResEvalOpenChannel.txt");
	fileStream.open(file_name,ofstream::app) ;
        if (fileStream.is_open()){
		return 0;
	}
	return -1;
}


int doit (int argc, char* argv[])
{
  Spread::Network Primaire;
  Primaire.initialize( &argc,&argv );
  AC::Network* netPrim = &Primaire;
  rank = netPrim->rank();
  if (rank == 0 ){initFile(0);}
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Secondaire.initializeDynamic( 0,&argv,&Primaire );
  net = &Secondaire;
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ping);
  Primaire.commit();
  int node_count = netPrim->node_count();
  Secondaire.commit();




  AC::Network::OutChannel* channel;
  // 0 envoie  tous ceux qui attendent
  int nb_communi = 0;
  int attPing = 0;
  int emetteur = 0;
  int nb_conn = 0;
  try{

 std::cout<<"node "<<rank<<" : "<<"ici"<<std::endl;
	if (net->rank() == 0)
 	{
		int peer = 1;
		for (int peer = 1 ; peer <net->node_count();peer++){
			gettimeofday(&time_init,0);
			net->open_channel(peer);
			gettimeofday(&time_term,0);

			std::cout<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec)<<"\n";
			fileStream<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec) <<"\n";

			channel = net->get_default_route(peer);
			AC::ActiveMessage<PingService> am (net, &ping, 0);
			am(channel);
		}
	}


   }catch(...){
   	std::cout<<"node "<<rank<<" : "<<"TEST : exception souleve!!!!!!!!!!!!!!!"<<std::endl;
   }
	emetteur++;

	if (net->rank() !=0)
 	{
		std::cout<<"node "<<rank<<" : "<<"en attente"<<std::endl;
		while (pingRecu < 1);
	}
std::cout<<"node "<<rank<<" : "<<"ready to terminate"<<std::endl;

   Secondaire.terminate();
   Primaire.terminate();
}



int main (int argc, char* argv[])
{
	doit(argc, argv);
  	if (rank ==0 )
  	{
		//std::cout<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec)<<"\n";
		//std::cout<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec)<<"\n";
		//fileStream<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec) <<"\n";
		fileStream.close();
  	}
	return 0;
}
