//
// $Id: testAllToOne.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// test active message: a call to one service from rank 0 with nul msg
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>

namespace AC = acom;
static volatile bool terminate = false;
static AC::Network* net=0;
static int nbMsg=2;
static int nbMsgRecu = 0;

class Msg: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
        nbMsgRecu++;
	std::cout << "Node "<<h->dst <<" : nb msg recu "<<nbMsgRecu<<" / "<<nbMsg*(net->node_count()-1)<<std::endl;
	//std::cout << "Node "<<h->dst <<" : Reception msg n"<<*(int*) iov[0].data<<" en provenance du noeud "<<h->src<<std::endl;
	if (e != AC::ComFailure::OK)
		std::cout << "TEST : Error" << std::endl;
	if ( nbMsgRecu == nbMsg*(net->node_count()-1) ){
		std::cout << "Node "<<h->dst <<" : tertminate est a true"<<std::endl;
		terminate = true;
	}
  }
};

static Msg message;


int doit (int argc, char* argv[])
{



/*// INITIALISATION avec secondaire*/
  Spread::Network Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Primaire.initialize( &argc,&argv );
  Secondaire.initialize( 0,&argv,&Primaire );
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 5, &message);
  net = &Secondaire;
  Primaire.commit();
  Secondaire.commit();/**/

  std::cout<<"node "<<net->rank()<<" : "<<"Initialisation et commit -> Ok\n\n\n"<<std::endl;

  AC::Network::OutChannel* channel;
  int recepteur = 0;

for (int i = 0;i<nbMsg;i++){

	if (net->rank() != recepteur)
	{
	 	// Get a channel:
		AC::ActiveMessage<Msg> am (net, &message, 0);
		try{
			channel = net->get_default_route(recepteur);
		   	am->put(&i,sizeof(int));
			am(channel);
    		}catch(...){
 		     std::cout<<"node "<<net->rank()<<" : "<<"TEST : exception souleve!!!!!!!!!!!!!!!"<<std::endl;
   		}
	}

}

if (net->rank() == recepteur && !terminate)
{
 	std::cout<<"node "<<net->rank()<<" : "<<"TEST : en attente de reception du message"<<std::endl;
 	while (!terminate)
 	{
		usleep( 1000 );
	}
}



  Secondaire.terminate();
  std::cout << "\n\n\nnode "<<net->rank()<<" : "<<"*****    TEST : Ready to Terminate   *****" << std::endl;
  Primaire.terminate();
}

int main (int argc, char* argv[])
{
   return doit(argc, argv);
}
