/* Cyrille Martin */
/* laboratoire ID-IMAG, BULL*/
/* Projet LIPS action DYADE*/
/* 07/06/2001 */

#ifndef __REXEC_H
#define __REXEC_H


#include <vector>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "connector.h"

class Srexec:public connector
{
  void run()
	{
		struct servent* sp;
		int tcpopt_nodelay_on=1;

		sp = getservbyname("exec","tcp");

		for(int i=0; i<remote_hosts.size(); i++)
			{
				char* r_host;
				r_host = strcpy((char*)malloc(remote_hosts[i]->name.size()),remote_hosts[i]->name.c_str());
				if ((remote_hosts[i]->fd = rexec((char**)&r_host,sp->s_port, remote_hosts[i]->login.c_str(),remote_hosts[i]->passwd.c_str(),remote_hosts[i]->cmd.c_str(), NULL)) <0)
		{
			reject->push_back(remote_hosts[i]);
		}
				if(setsockopt(remote_hosts[i]->fd,IPPROTO_TCP,TCP_NODELAY,&tcpopt_nodelay_on,sizeof(tcpopt_nodelay_on))==-1)
		{
			perror("WARNING:");
		}
			}
	}
};

#endif //__REXEC_H
