%{
#include <iostream>
#include "analyser_yacc.h"
 extern  int yylval;
 extern  char* yycopy;
int lineno=1; // line number

%}

%%
"//".*\n                    { lineno++;}
[\t ]+ 
\n                          { std::cout << lineno << std::endl ; lineno++;}
#include                    { return DIESEINCLUDE;}
USE_TRACER                  { return USETRACER; }
TRACER                      { return TRACER; }
"using namespace"           { return UNS; }
LEVEL                       { return LV; }
EVENT                       { return EVT; }
[_a-zA-Z][\._a-zA-Z0-9]+    { yylval= (int) strdup(yytext); return NOM; }
[0-9]+                      { yylval=atoi(yytext);  return NOMBRE; }
","                         { return VIRG; }
";"                         { return PVIRG; }
"\""                        { return GUILM; }
"\*"                        { return STAR; }
"("                         { return PARG; }
")"                         { return PARD; }
%%

