
// ---------------------------------------------------------------------
// ------------------------ BEGIN   MANUAL -------------------------------

/**

\mainpage  The Inuktitut portable library

\htmlonly <hr WIDTH="100%"> \endhtmlonly 
\section SPaim Objectives
\htmlonly <hr WIDTH="100%"> \endhtmlonly 

This is the documentation for the Inuktitut portable library which provides:
 - a portable thread package (Pthread)
 - a portable socket packages (Psocket)
 - @ref network_doc "a generic network framework (NetworkCore)"
 - a collection of collective communication services (ICS)
 - tracing facilities (Tumit)

This library also provides two primary networks (primary nets are used to deploy an application), one under CORBA (CORNET) and one being a launcher (TAKTUK). It also provides networks to be used for application communication during calculation (SOCKNET, TCPNET). 

\remarks Depending on the configuration and installation, some packages may not be installed and so may not be documented.



*/ //  DON'T REMOVE 


// ----------------------------- END OF MANUAL ----------------------------



