// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file for more information
// Header file for ICS library
//
//
// ==========================================================================
#ifndef _ICS_HEADER_H_
#define _ICS_HEADER_H_

#include <ics_conf.h>
#include <ics_system.h>
#include <ics_dns.h>
#include <ics_ack.h>
#include <ics_bcast_network.h>
#include <ics_bcastnet_flat.h> 
#include <ics_bcastnet_chain.h>
#include <ics_bcastnet_alpha.h>
#include <ics_redops.h>
#include <ics_reduce_network.h>
#include <ics_reducenet_flat.h> 
#include <ics_reducenet_chain.h>
#include <ics_barrier.h>
#include <ics_alphabarrier.h>
#include <ics_flatbarrier.h>
#include <ics_defaultbarrier.h>

#if 0 /* DEPRECATED */
#include <ics_bcast.h>
#include <ics_bcast_one_2_all.h>
#include <ics_bcast_alphatree.h>
#include <ics_bcast_chain.h>
#include <ics_bcast_alphachain.h>
#include <ics_bcast_compose.h>
#include <ics_reduce.h>
#include <ics_reduce_all_2_one.h>
#include <ics_reduce_alphatree.h>
#endif

/*!
\file  
\brief ICS library for Collective Service
\author  T. Gautier L. Pigeon
\date 2003
*/

#ifndef _ICS_INCLUDE_NOT_IN_GLOBAL_NAMESPACE_
using namespace ICS;
#endif

#endif
