// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_defaultbarrier.cpp,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of barrier as a service
// $Id: ics_defaultbarrier.cpp,v 1.2 2003/06/24 19:21:20 thierry Exp $
//
// ==========================================================================
#include <ics_defaultbarrier.h>
#include <iostream>

namespace ICS {


// -----------------------------------------------------------------------------
void DefaultBarrier::initialize( ACOM::Network* net )
{
  FlatBarrier::initialize(net);  
  AlphaBarrier::initialize(net);  
}

/** 
 */
void DefaultBarrier::barrier( int key )
{
  if (_net->node_count() < 12)
    FlatBarrier::barrier(key);
  else {
    double alpha =0.5;
    if (_net->node_count() <16) alpha =0.3;
    AlphaBarrier::barrier(key,alpha);
  }
} 



} // ICS namespace

