// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/ICS/src/ics_defaultbarrier.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file
// Author: T. Gautier
// Implementation of barrier as a service
// $Id: ics_defaultbarrier.h,v 1.2 2003/06/24 19:21:20 thierry Exp $
//
// ==========================================================================
#ifndef _INUK_DFLTBARRIER_H_
#define _INUK_DFLTBARRIER_H_
#include <acom>
#include <ics_flatbarrier.h>
#include <ics_alphabarrier.h>

namespace ICS {

/* 
 * Bcast service for inuktitut
 */
class DefaultBarrier: virtual public FlatBarrier, virtual public AlphaBarrier {

public:

  /** */
  DefaultBarrier()
  { }

  /** */
  void initialize( ACOM::Network* net );

  /** */
  void barrier( int key );

protected:
};

}

#endif
