// ==========================================================================
// $Source: /users/huron/gautier/CVS/Inuktitut2/Pthread/src/pth.h,v $
// Copyright(c)'2001 by Apache Team
// see the copyright file for more information
// Author: J Briat T.Gautier
// Header file for Inuktitut/Thread/Pthread
// ==========================================================================
#ifndef _PTH_CPLUSPLUS_H_
#define _PTH_CPLUSPLUS_H_

#include "pth_ns.h"
#include "pth_dep.h"
#include "pth_macro.h"
#include "pth_basic.h"
#include "pth_system.h"
#include "pth_pthreadsync.h"
#include "pth_pthreadsync.inl"
#include "pth_staction.h"
#include "pth_error.h"
#include "pth_log.h"
#include "pth_atomic.h"
#include "pth_util.h"
#include "pth_time.h"

/*!
\file  
\brief Interface to Posix thread for Inuktitut0 INRIA.(To be used outside namespace PTH)
\author  J. Briat T. Gautier 
\date 2001
*/

/* Compatibility
*/
namespace PTH {
typedef ThreadId ThId;
typedef Thread   Th;
}

#ifndef _PTH_INCLUDE_NOT_IN_GLOBAL_NAMESPACE_
using namespace PTH;
#endif

#endif
