#include "tr_recorder.h"
#include "tr_recorder.h"
#include "pth_pthreadsync.inl"
namespace PTH 
{
  void SimpleRecorder::initialize(  char * fn)throw(PosixError)
  { // A REVOIR AVEC PTHREAD
	++_usedCt;
    if(_usedCt >1) return ; // not the first call 
    SimpleBufferManager::init();
    _clk=new PhysicalClock() ; initBinder(); openTraceFile(fn);  
  };
  
  void SimpleRecorder::terminate()
   { 
    // to do : close & save all buffer..
    --_usedCt; if(_usedCt==0){saveFreeAllBuffer();closeTraceFile() ; }
  };

  void SimpleRecorder::commit()
  { };


void SimpleBufferManager::saveFreeAllBuffer(){ SimpleBuffer * buf;
  //----------------------list_buffer---------------------------
 CRITICAL_NOTRACE (mutex_list_buffer);   
//std::cout<< "    list_buffer size = "<< list_buffer.size() << std::endl;
  while(!list_buffer.empty()){
//std::cout<< " list_buffer item = "<< list_buffer.front() << " threadid= "<< list_buffer.front()->_tid<<std::endl;
     buf= list_buffer.pull_front();
        saveBuffer(buf); 
	}  
//---------------------------------------------------------------

}

}
