/* test simple pour traceur Pthread
 *	PTH:: init commit terminate
 *	Thread create
 *	CRITICAL CriticalGuard condition mutex 
 */


#include <iostream>
#include <unistd.h>
#include <stdlib.h>
#include <string>

#include "pth.h"

#define STRING_TEST(str) 

const int nb_iterations=200;
const int tempo=20000;

static Mutex mon_mutex;

int nb_gateaux=0;
int dodo_time;
std::string tests1= "  coucou !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!et BYE";
std::string tests2= "  BLABLA ???????????????????et BYE";

static Mutex mtx_cnd;
Condition cnd;
int j,k=0;

Thread p1,p2,c;

void* consome(void *)
{ 
  while(j<nb_iterations)
    {
      CRITICAL (mon_mutex);
      if (nb_gateaux > 0)
	{
	  nb_gateaux--;
	  j++;
	  dodo_time = random()/tempo;
STRING_TEST(tests1);
	  std::cout << j << " Je mange... nbg="<< nb_gateaux << std::endl ;
	  usleep(dodo_time);
	}
      else 
	{
	  PTH::Th::yield();
	}
    }

  mtx_cnd.lock();
  cnd.signal();
  mtx_cnd.unlock();
  
return NULL;
}

void* produit(void *)
{
  while(k<nb_iterations)
    {
      CriticalGuard gd(mon_mutex);
      if (nb_gateaux < 10)
	{
	  nb_gateaux++;
	  k++;
	  dodo_time=random() / tempo; 
STRING_TEST(tests2);
	  std::cout << k << " Je cuisine... nbg="<< nb_gateaux  << std::endl ;
	  usleep(dodo_time);
	}
      else
	{
	  PTH::Th::yield();
	}
    }

  return NULL;
}

int main(int argc, char* argv[])
{

  ThreadId tidc;
  ThreadId tidp1;

  PTH::Pth::initialize(&argc, &argv);
  PTH::Pth::commit();

  cnd.init();

  c.create(&tidc, consome, NULL);
  p1.create(&tidp1, produit, NULL);
 
  mtx_cnd.lock();
  std::cout << "dans mtx_cnd" << std::endl;  
  cnd.wait(mtx_cnd);
  mtx_cnd.unlock();


  std::cout << "apres pthread_exit" << std::endl;
  PTH::Pth::terminate();
  std::cout << "apres PTH::Pth::terminate" << std::endl;

  return 0;
}
