//
// $Id: EvalInitDyn.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// Envoi de NB_COM messages, chaque msg est envoy sur une liaison diffrente et entraine donc dans le cas d'un rseau dynamqieu l'ouverture d'une nouvelle liaison
//
#include <cstring>
#include <cstdio>
#include <acom>
#include <acom_tcp_net.h>
#include <spread_net.h>
#include <sock>
#include <pth>
#include <iostream>
#include <fstream.h>
#include <sys/time.h>


namespace AC = acom;

static int NB_COM = 0;
static int rank = -1;
static volatile int pingRecu = 0;
AC::Network* net = 0;

//perf time counter
timeval time_init;
timeval time_term;


class PingService: public AC::Service {
public:
  void call (
       AC::ComFailure::Code e,      // if any
       AC::Network::Receipt* receipt,
       AC::Network::Header* h,
       AC::IOVectEntry* iov,
       AC::IOVectSize   iov_sz
  ) throw (AC::ComFailure)
  {
          pingRecu++;
  }
};

static PingService ping;


int doit (int argc, char* argv[])
{

  Spread::Network Primaire;
  Primaire.initialize( &argc,&argv );
  AC::Network* netPrim = &Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Secondaire.initialize( 0,&argv,&Primaire );
//Secondaire.initializeDynamic( 0,&argv,&Primaire );
  net = &Secondaire;
  AC::Service::Manager.bind (AC::ServiceManager::TCP_LNS, 4, &ping);
  Primaire.commit();


  int node_count = netPrim->node_count();
  NB_COM = atoi(argv[1]);

  /*****************	if (netPrim->rank() ==0 ){gettimeofday(&time_init,0);} ************/

  Secondaire.commit();
  AC::Network::OutChannel* channel;


  int attPing = 0;
  int emetteur = 0;
  int dest = emetteur + 1;

  if (NB_COM > (netPrim->node_count()*(netPrim->node_count()-1)/2))
  {
	std::cout<<"ERREUR nombre de noeud insuffisant !!!"<<std::endl;
  }
  else
  {
  	for (int i = 0; i< NB_COM; i++)
	{
		if (net->rank() == emetteur)
		{
			channel = net->get_default_route(dest);
			AC::ActiveMessage<PingService> am (net, &ping, 0);
			am(channel);
		}
		if (net->rank() == dest)
		{
			attPing++;
		}
		dest++;
		if (dest >= net->node_count()){
			emetteur++;
			dest = emetteur+1;
		}
	}
	 
	while (pingRecu<attPing)
	{
	  	usleep( 1000 );
	}

	 
	
  }


  /*****************	 if (netPrim->rank() ==0 ){gettimeofday(&time_term,0);} **************/
  Secondaire.terminate();
 /*  if (netPrim->rank() ==0 )
   {
     std::cout<<"Temps "<<NB_COM<<" "<<((double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec)) <<"\n";
   }*/
  Primaire.terminate();


}



int main (int argc, char* argv[])
{

	doit(argc, argv);
	return 0;
}
