//
// $Id: EvalInitPrimSec.cpp,v 1.1.1.1 2003/05/26 15:59:28 olobry Exp $
//
// mesure les tempsdes diffrentes initialisation de TCP net
//

#include <acom_tcp_net.h>
#include <spread_net.h>
#include <fstream.h>
#include <sys/time.h>


namespace AC = acom;
//lke noeud 0 communique avec NB_COM  noeuds
static int rank = -1;
AC::Network* net = 0;
static int node_count = 0;

std::ofstream fileStream;
//perf time counter
timeval time_init;
timeval time_term;
timeval time_init2;
timeval time_term2;



int initFile (int i)
{
	char file_name[19];
   	if (i==0)
	{
		strcpy (file_name,"evalInitPrim.txt");
	}else if (i==1){

		strcpy (file_name,"evalInitSec.txt");
	}else {

		strcpy (file_name,"evalInitSecDyn.txt");
	}
	//fileStream.open(file_name) ;
        fileStream.open(file_name,ofstream::app) ;
        if (fileStream.is_open()){
		return 0;
	}
	return -1;
}

int initPrim (int argc, char* argv[])
{
  /*****************/	gettimeofday(&time_init,0); /**************/
  TCP_NET_NAMESPACE::tcp_net Primaire;
  Primaire.initialize( &argc,&argv );
  AC::Network* netPrim = &Primaire;
  Primaire.commit();

  rank = netPrim->rank();
  node_count = netPrim->node_count();

  Primaire.terminate();
  /*****************/	 gettimeofday(&time_term,0); /**************/
  if (rank == 0 ){initFile(0);}
  return 0;
}


int InitSec (int argc, char* argv[])
{

  /*****************/	gettimeofday(&time_init,0); /**************/
  Spread::Network Primaire;
 Primaire.initialize( &argc,&argv );
  AC::Network* netPrim = &Primaire;

  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Secondaire.initialize( 0,&argv,&Primaire );
  net = &Secondaire;
  if(Primaire.commit()<0)
    {
      //spread.IO_on();
      std::cerr<<"rshp can't connect several host :"<<std::endl;
      Primaire.print_rejected();
    }
  Secondaire.commit();

  rank = netPrim->rank();
  node_count = netPrim->node_count();

  //Secondaire.barrier();
  Secondaire.terminate();
  Primaire.terminate();
  /*****************/	 gettimeofday(&time_term,0); /**************/
  if (rank == 0 ){initFile(1);}
  return 0;
}

int InitSecDyn (int argc, char* argv[])
{
  /*****************/	gettimeofday(&time_init,0); /**************/
  Spread::Network Primaire;
  Primaire.initialize( &argc,&argv );
  AC::Network* netPrim = &Primaire;
  TCP_NET_NAMESPACE::tcp_net Secondaire;
  Secondaire.initializeDynamic( 0,&argv,&Primaire );
  net = &Secondaire;
  if(Primaire.commit()<0)
    {
      //spread.IO_on();
      std::cerr<<"rshp can't connect several host :"<<std::endl;
      Primaire.print_rejected();
    }
  Secondaire.commit();

  rank = netPrim->rank();
  node_count = netPrim->node_count();

  Secondaire.terminate();
  Primaire.terminate();
  /*****************/	 gettimeofday(&time_term,0); /**************/
  if (rank == 0 ){initFile(2);}
  return 0;
}

int main (int argc, char* argv[])
{
	//initPrim(argc,argv);
	InitSec(argc,argv);
	//InitSecDyn(argc,argv);
	if (rank ==0 )
  	{
		std::cout <<node_count <<"     "<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec)<<"\n";
		fileStream<<node_count <<"     "<<(double)( time_term.tv_sec - time_init.tv_sec)+0.000001*(double)(time_term.tv_usec - time_init.tv_usec) <<"\n";
		fileStream.close();
  	}
	return 0;
}
