%{
#include <iostream>
#include <sstream> 
#include <string.h>
#include "tab_rec_ana_yacc.h"

#define SORTIE cout

extern int yylval;
extern char* yycopy;
int lineno=1; // line number

std::ostringstream sdb;

using namespace std;
%}

%%
[\t ]+ {SORTIE << " ESP ";}
"//".*\n       { lineno++; SORTIE << " COMM ";}
"%".*\n        { lineno++; yylval = (int) strdup(yytext); SORTIE << " LENTETE "; return LENTETE;}
"#".*\n        { lineno++; yylval = (int) strdup(yytext); SORTIE << "\n LPDP ";   return LPDP;}
\n             { lineno++; }
\"[a-zA-Z0-9_\- @][\._a-zA-Z0-9\- @]*\"   { yylval = (int) strdup(yytext); SORTIE << " STRING(" << yytext << ") "; return STRING;}
[a-zA-Z_\-][\._a-zA-Z0-9\-]* { yylval = (int) strdup(yytext); SORTIE << " NOM(" << yytext << ") " ; return NOM;}
[0-9]+         { yylval = atoi (yytext); SORTIE << " NOMBRE(" << yytext <<") "; return NOMBRE;}
"->"           { SORTIE << "\n FLECHE "; return FLECHE;}
","            { SORTIE << " VIRG "; return VIRG;}
"("            { SORTIE << "\n PARG ";return PARG;}
")"            { SORTIE << " PARD "; return PARD;}
%%
